grammar ADT;

import TreeAndLexerRules;

/*
 * Parser Rules
 */

adt         : name? sorts constructors? operations (vars axioms)? EOF ;

name        : 'name' BEZ ;

sorts       : 'sorts' sort (',' sort )* ;
sort: BEZ ;

constructors: 'constructors' operation+ ;
operations  : 'operations' operation+ ;
operation   : BEZ ':' (sort ('><' sort)* '->')? sort ;

vars: 'vars' var (',' var)* ;
var : BEZ ':' sort ;

// mytree imported from TreeAndLexerRules

axioms      : 'axioms' axiom+ ;
axiom       : BEZ ':' eq_s ;